# 거래내역 수집 요청

## 1. RequestJob - 수집 요청

| HTTP Method | 테스트(Sandbox)                                                  | 운영(Production)                                           |
| ----------- | ------------------------------------------------------------- | -------------------------------------------------------- |
| POST        | <https://popbill-test.linkhub.co.kr/EasyFin/Bank/BankAccount> | <https://popbill.linkhub.co.kr/EasyFin/Bank/BankAccount> |

- 계좌 거래내역 수집을 팝빌에 요청합니다.
- 최대 1개월 단위로 수집 요청이 가능하며, 조회일로부터 최대 3개월 이전 내역까지 조회가 가능합니다.
- API를 호출하고 반환 받은 작업아이디(JobID)는 수집을 요청한 시점으로부터 1시간 동안만 유효합니다.

### Request

**요청 헤더**

- Authorization `required: Y` `description: 인증 토큰`
  - [\[참고\] 인증 및 헤더 설정](https://developers.popbill.com/api-reference/easyfinbank/getting-started/authorization)
- Accept-Language `required: N` `description: 응답 언어 설정`
  - `ko-KR`: 기본값
  - `en-US`
- Accept-Encoding `required: N` `description: 응답 압축 방식`
  - `gzip`
- X-PB-UserID `required: N` `description: 팝빌회원 아이디`

**Query 파라미터**

- BankCode `type: string` `length: 4` `required: Y` `description: 은행 기관코드`
  - [\[참고\] 조회 가능한 금융기관](https://developers.popbill.com/guide/easyfinbank/introduction/easy-intro#banklist)
- AccountNumber `type: string` `length: 30` `required: Y` `description: 계좌번호`
- SDate `type: string` `length: 8` `required: Y` `description: 검색 시작일자`
  - 형식 : yyyyMMdd
- EDate `type: string` `length: 8` `required: Y` `description: 검색 종료일자`
  - 형식 : yyyyMMdd

**요청 예시**

```bash
curl --request POST \
  --url 'https://{domain}/EasyFin/Bank/BankAccount?AccountNumber={AccountNumber}&BankCode={BankCode}&SDate={SDate}&EDate={EDate}' \
  --header 'Authorization: Bearer {token}'
```

### Response

**응답 본문**

- jobID `type: string` `length: 18` `description: 작업아이디`

**응답 예시**

```json
{
    "jobID": "025102210000000001"
}
```

## 2. GetJobState - 수집 상태 확인

| HTTP Method | 테스트(Sandbox)                                                    | 운영(Production)                                             |
| ----------- | --------------------------------------------------------------- | ---------------------------------------------------------- |
| GET         | <https://popbill-test.linkhub.co.kr/EasyFin/Bank/{jobID}/State> | <https://popbill.linkhub.co.kr/EasyFin/Bank/{jobID}/State> |

- [\[RequestJob - 수집 요청\]](https://developers.popbill.com/api-reference/easyfinbank/api/job#RequestJob) API를 호출하고 반환 받은 작업아이디(JobID)를 이용하여 수집 상태를 확인합니다.
- 수집 상태(jobState) = 3(완료)이면서, 수집 결과코드(errorCode) = 1(수집성공)인 경우 [\[Search - 수집 내역 확인\]](https://developers.popbill.com/api-reference/easyfinbank/api/search#Search) 이 가능합니다.

### Request

**요청 헤더**

- Authorization `required: Y` `description: 인증 토큰`
  - [\[참고\] 인증 및 헤더 설정](https://developers.popbill.com/api-reference/easyfinbank/getting-started/authorization)
- Accept-Language `required: N` `description: 응답 언어 설정`
  - `ko-KR`: 기본값
  - `en-US`
- Accept-Encoding `required: N` `description: 응답 압축 방식`
  - `gzip`
- X-PB-UserID `required: N` `description: 팝빌회원 아이디`

**Path 파라미터**

- jobID `type: string` `length: 18` `required: Y` `description: 팝빌에서 할당한 작업아이디`
  - [\[RequestJob - 수집 요청\]](https://developers.popbill.com/api-reference/easyfinbank/api/job#RequestJob) API의 반환값

**요청 예시**

```bash
curl --request GET \
  --url 'https://{domain}/EasyFin/Bank/{jobID}/State' \
  --header 'Authorization: Bearer {token}'
```

### Response

**응답 본문**

- jobID `type: string` `length: 18` `description: 팝빌에서 할당한 작업아이디`
- jobState `type: number` `length: 1` `description: 수집 상태`
  - `0`: 접수
  - `1`: 대기
  - `2`: 진행
  - `3`: 완료
- startDate `type: string` `length: 8` `description: 시작일자`
  - [\[RequestJob - 수집 요청\]](https://developers.popbill.com/api-reference/easyfinbank/api/job#RequestJob)에 입력한 SDate (형식 : yyyyMMdd)
- endDate `type: string` `length: 8` `description: 종료일자`
  - [\[RequestJob - 수집 요청\]](https://developers.popbill.com/api-reference/easyfinbank/api/job#RequestJob)에 입력한 EDate (형식 : yyyyMMdd)
- errorCode `type: number` `length: -` `description: 수집 결과코드`
  - 성공 : 1
  - 실패 : 음의 정수 8자리 숫자값 [\[참고\] 오류코드](https://developers.popbill.com/error-code)
- errorReason `type: string` `length: -` `description: 오류메시지`
  - 수집실패시 반환되는 사유
- jobStartDT `type: string` `length: 14` `description: 작업 시작일시`
  - 형식 : yyyyMMddHHmmss
- jobEndDT `type: string` `length: 14` `description: 작업 종료일시`
  - 형식 : yyyyMMddHHmmss
- regDT `type: string` `length: 14` `description: 수집 요청일시`
  - 형식 : yyyyMMddHHmmss

**응답 예시**

```json
{
    "jobID": "025102111000000005",
    "jobState": 3,
    "startDate": "20251001",
    "endDate": "20251020",
    "errorCode": 1,
    "errorReason": "수집 완료",
    "regDT": "20251021112242"
}
```

## 3. ListActiveJob - 수집 상태 목록 확인

| HTTP Method | 테스트(Sandbox)                                              | 운영(Production)                                       |
| ----------- | --------------------------------------------------------- | ---------------------------------------------------- |
| GET         | <https://popbill-test.linkhub.co.kr/EasyFin/Bank/JobList> | <https://popbill.linkhub.co.kr/EasyFin/Bank/JobList> |

- [\[RequestJob - 수집 요청\]](https://developers.popbill.com/api-reference/easyfinbank/api/job#RequestJob) API를 호출하고 반환 받은 작업아이디(JobID) 목록의 수집 상태를 확인합니다.

### Request

**요청 헤더**

- Authorization `required: Y` `description: 인증 토큰`
  - [\[참고\] 인증 및 헤더 설정](https://developers.popbill.com/api-reference/easyfinbank/getting-started/authorization)
- Accept-Language `required: N` `description: 응답 언어 설정`
  - `ko-KR`: 기본값
  - `en-US`
- Accept-Encoding `required: N` `description: 응답 압축 방식`
  - `gzip`
- X-PB-UserID `required: N` `description: 팝빌회원 아이디`

**요청 예시**

```bash
curl --request GET \
  --url 'https://{domain}/EasyFin/Bank/JobList' \
  --header 'Authorization: Bearer {token}'
```

### Response

**응답 본문**

- jobID `type: string` `length: 18` `description: 팝빌에서 할당한 작업아이디`
- jobState `type: number` `length: 1` `description: 수집 상태`
  - `0`: 접수
  - `1`: 대기
  - `2`: 진행
  - `3`: 완료
- startDate `type: string` `length: 8` `description: 시작일자`
  - [\[RequestJob - 수집 요청\]](https://developers.popbill.com/api-reference/easyfinbank/api/job#RequestJob)에 입력한 SDate (형식 : yyyyMMdd)
- endDate `type: string` `length: 8` `description: 종료일자`
  - [\[RequestJob - 수집 요청\]](https://developers.popbill.com/api-reference/easyfinbank/api/job#RequestJob)에 입력한 EDate (형식 : yyyyMMdd)
- errorCode `type: number` `length: -` `description: 수집 결과코드`
  - 성공 : 1
  - 실패 : 음의 정수 8자리 숫자값 [\[참고\] 오류코드](https://developers.popbill.com/error-code)
- errorReason `type: string` `length: -` `description: 오류메시지`
  - 수집실패시 반환되는 사유
- jobStartDT `type: string` `length: 14` `description: 작업 시작일시`
  - 형식 : yyyyMMddHHmmss
- jobEndDT `type: string` `length: 14` `description: 작업 종료일시`
  - 형식 : yyyyMMddHHmmss
- regDT `type: string` `length: 14` `description: 수집 요청일시`
  - 형식 : yyyyMMddHHmmss

**응답 예시**

```json
[
    {
        "jobID": "025102111000000005",
        "jobState": 3,
        "startDate": "20251001",
        "endDate": "20251020",
        "errorCode": 1,
        "errorReason": "수집 완료",
        "regDT": "20251021112242"
    }
]
```
